# Eighteenth International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
on how to compile the entry and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details.

Some ANSI C compilers are not quite as good as they should be.  If
yours is lacking, you may need to compile using `gcc` instead of your
local compiler.

This year we included most of the information included by the submitters
in the `README.md` files (that were used to build the `index.html` web pages).


### Historical note:

The IOCCC has a website and now has a number of international mirrors.
The primary website can be found at [www.ioccc.org](https://www.ioccc.org).


### Historical update:

The IOCCC website once had a number of
[international mirrors](https://web.archive.org/web/20201030210517/https://www.ioccc.org/mirror.html).
As of 2020 Dec 29, [GitHub](https://www.github.com) serves as the distributed server farm for the
[IOCCC winner repo](https://github.com/ioccc-src/winner) that GitHub renders as
[Official IOCCC website - www.ioccc.org](https://www.ioccc.org).


## Remarks on some of the entries

We believe you will be impressed with this year's winning entries.

In particular:

+ The [Abuse of the rules - 2005/klausler](klausler/index.html) used local dictionary data to
get around the size limit.

+ The [Most beauteous visuals - 2005/vince](vince/index.html) made clever use of `{}`s and
whitespace in their source code and during execution.

+ The [Most circuitous walk - 2005/vik](vik/index.html) entry is just amazing.

+ The [Best game - 2005/toledo](toledo/index.html) makes full use of its single function.

+ The [Best emulator - 2005/sykes](sykes/index.html) may allow you to reconnect to your first
[PET](https://en.wikipedia.org/wiki/Commodore_PET).

+ Our [Best of Show - 2005/persano](persano/index.html) this year was simply (or non-simply :-) ) the best!

+ (And we need only mention (parenthetically speaking) that the [Best use of
parenthesis](mikeash/index.html) is self reproducing).

+ The [Most sonorous output - 2005/jetro](jetro/index.html) might `sound` :-) like a good idea.

+ The [Best 2D puzzle - 2005/giljade](giljade/index.html) takes editorial license with expressions as well as the
with the [vi editor](https://en.wikipedia.org/wiki/Vi_&lpar;text_editor&rpar;).

+ The [Most ambiguous language - 2005/chia](chia/index.html) entry is really a C program.

+ The [Most superfluous output - 2005/boutines](boutines/index.html) entry is simply
[Voronoi](https://en.wikipedia.org/wiki/Voronoi_diagram)-lific!

+ Try not to have your sense of good coding offended by the [Most
discourteous interpreter - 2005/timwi](timwi/index.html) entry.

+ The [Best use of the www - 2005/mynx](mynx/index.html) doesn't include those letters.

+ You will be puzzled by the [Best 3D puzzle - 2005/anon](anon/index.html) entry; we are sure!

+ The [Most ingenious puzzle solution - 2005/aidan](aidan/index.html) might puzzle you more while it
puzzles out some puzzles: all in a puzzling way!  :-)


### Remarks on some of the losing entries

There were some outstanding entries that did not win.  Unfortunately
some very good entries lost because they:

+ depended too much on non-portable side effects in expressions; and/or

+ depended too much on a particular byte order; and/or

+ required the use of a special script, data file or pseudo-machine
  language that was not supplied with the entry.

We hope the authors of some of those entries will fix and resubmit
them for the next IOCCC.


## Final Comments

**IMPORTANT NOTE**: See [contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also the [IOCCC FAQ](../faq.html) for additional information on the IOCCC.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

        Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

        https://creativecommons.org/licenses/by-sa/4.0/

-->
